;
;	2K STAND-ALONE MONITOR/DEBUG PACKAGE
;
;
;	SYSTEM VARIABLE DEFINITIONS
;
	TITLE	'2K STAND ALONE MONITOR REV 2 Jan 6 86'
	PAGE	50
;
ROMPTR	EQU	0F800H	;FIRMWARE LOCATION
RAMPTR	EQU	0F000H	;ADDR OF RAM
BASE	EQU	40H	; IO PORT ADDRESS BASE

;
PROMPT	EQU	'>'	;SCREEN PROMPT
VARSIZE	EQU	100
MEMCTRL	EQU	3EH	;Z80 CPU DISABLE
ROMTOP	EQU	0FFFH	;ROM SIZE
;********************************************************
;	VALID COMMAND BYTE ONE FOR OMNI CONTROLLER	*
;	   (THESE EQUATES ARE COPIED FROM BIOS)		*
;********************************************************

OC$BOOT	EQU	0		;BOOT SYSTEM
OC$SWRT	EQU	1		;WRITE SYSTEM (INVERSE OF BOOT)
OC$MODE EQU	2		;DMA/IO MODE
*C$FMTF	EQU	3		;FORMAT FLOPPY TRACK
*C$DLDS EQU	4		;DEFINE LOGICAL DEVICE SET
OC$GLDS	EQU	5		;GET LOGICAL DEVICE SET
*C$FWRT	EQU	6       	;FORCE WRITE OF MODIFIED BUFFERS
OC$RBPH	EQU	7		;RESET BOOT PHANTOM
*C$----	EQU	8		;NOT ASSIGNED
OC$UNIT	EQU	9		;SELECT (LOGICAL) UNIT
OC$TRAK	EQU	10		;SELECT TRACK
OC$RECD	EQU	11		;SELECT (LOGICAL) RECORD
OC$DADR	EQU	12		;SET DMA ADDRESS
OC$READ	EQU	13		;READ
OC$WRIT	EQU	14		;WRITE
OC$HEAD	EQU	15		;SET HEAD (NOT USED, ANYWHERE)
*C$----	EQU	16		;NOT ASSIGNED
OC$GDPB	EQU	17		;GET DPB (GET CP/M DPB FROM OMNI)
*C$----	EQU	18		;NOT ASSIGNED
*C$SSEK EQU	19		;NON-IMPYED SEEK (NOT USED IN BIOS)
*C$TIOR	EQU	20		;DEBUG READS FROM OMNI
*C$TIOW	EQU	21		;DEBUG WRITES TO OMNI
OC$GENS EQU	22		;GET GENERAL STATUS
OC$EXTS	EQU	23		;GET EXTENDED STATUS

OMNIDATA EQU	0A0H		;<== DATA PORT FOR OMNI CONTROLLER
OMNISTAT EQU	OMNIDATA+1	;STATUS PORT FOR OMNI
INREADY  EQU	01H		;** OMNI HAS DATA TO SEND
OUTREADY EQU	80H		;** OMNI CAN NOT ACCEPT ANOTHER BYTE NOW

	PAGE
;
;	****  INTERNAL MPU-Z IDENTIFICATION  ****
;
	ORG  ROMPTR+7FEH
	DB   'Z',23H
;
;*******************************************************************
;
;	SYSTEM RAM ALLOCATION
;
;*******************************************************************
;
	ORG  RAMPTR+256-VARSIZE
;
;*******************************************************
; COMMAND STRING FOR FULCRUM OMNI DISK INTERFACE
;	AND WORK AREA FOR THE DISPLAY COMMAND
;*******************************************************
LINE
DSKCMDST
CMDUNIT	DS 1		;COMMAND+UNIT #
DSTATUS DS 1		;STATUS
DTRACK	DS 2		;TRACK #
DSECTOR	DS 1		;SECTOR NUMBER
DBUF	DS 2		;RAM BUFFER LOCATION
RES	DS 10		;RESERVED
;*******************************************************
;
;
;*******************************************************
;	STORAGE IN  MPU-Z  RAM
;*******************************************************
DISKDRV	DS 1		;DRIVE TYPE SELECT BYTE
INDEV	DS 1		;INPUT DEVICE SELECT BYTE
OUTDEV	DS 1		;OUTPUT DEVICE SELECT BYTE
VRAMPTR	DS 2		;AVAILABLE RAM POINTER FOR DIRECT I/O
IORAM	DS 3		;RAM FOR DIRECT I/O COMMANDS
ASAVE	DS 1		;A REG SAVE AREA
DSTRBUF DS 2		;ADDR OF DISK COMMAND STRING BUFFER
SETADR	DS	1	;ADDRESS OF VALUE BEING SET
CBUFF	EQU	$	
SEC1	DS	1
SEC10	DS	1
MIN1	DS	1
MIN10	DS	1
H1	DS	1
H10	DS	1
DAY	DS	1
DAY1	DS	1
DAY10	DS	1
MO1	DS	1
MO10	DS	1
Y1	DS	1
Y10	DS	1
	PAGE
;************************************************
;ENTRY HERE IS ON POWER UP OR SYSTEM RESET
;************************************************
	ORG ROMPTR
ROM1	LXI  SP,RAMPTR+256-VARSIZE
;
INITSERA:
	LXI  H,IORAM	;GET ADDR OF WHERE TO DO I/O INTRUCTIONS
	SHLD VRAMPTR	;SAVE IN RAM I/O AREA
;INITILIZE 2681 PORT A CONTROLL JUNK
	MVI	A,1DH	;8 BIT DATA NO PARITY
	OUT	BASE + 1
	OUT 	BASE + 3
	MVI	A,0FH	;XMIT RCV BOTH 19200
	OUT	BASE + 5
	OUT	BASE + 6

	CALL TRYBOOT	;FIND MAIN DRIVE AND TRY TO READ IN A SECTOR
	ORA	A		;GENERAL STATUS
	JZ	BOOTER		;IF BOOT READ OK, GO FIRE UP BOOT
	CALL SETSYSP	;SET UP I/O PORTS BY HITTING SPACE BAR
;
SIGN	LXI H,SIGNON
	CALL SYSMSG	;"FULCRUM MPU-Z MONITOR REV 2"
	PAGE
;******************************************
;
;	PROMPT ROUTINE
;
; * ROUTINES DISPATCHED FROM COMMAND ROUTINE RETURN HERE *
;
PRMPTSP	LXI  SP,RAMPTR+256-VARSIZE
PRMPT	LXI  H,PRMPT
	PUSH H		;RETURN ADDRESS IN STACK
	CALL CRLF
	MVI  A,PROMPT
	CALL SYSOUT	;PRINT PROMPT CHARACTER
	CALL CHIN	;CLEAR INPUT
;
;****************************************
;
;	COMMAND DISPATCH ROUTINE
;
;****************************************
	LXI  H,CMDTBL
CMDFIND	CALL SYSIN	;GET COMMAND
	CALL LOOKUP	;LOOK UP COMMAND ADDRESS
	RZ		;RETURN IF COMMAND IS INVALID
	CALL SPACE
	MVI  B,1	;SET B TO KNOWN VALUE FOR VARIOUS ROUTINES
	PCHL		;DO COMMAND
;
TBLSET2	LXI  H,CMDTBL2	;GET ADDR FOR SECOND CMD TABLE
	JMP  CMDFIND
;
	PAGE
;
;****************************************
;	TRY INITIAL BOOT
;****************************************
TRYBOOT			;CODE TO EXECUTE COLD BOOT
;
;
	IN	OMNIDATA	;READ&TRASH TO RESET ANY TRASH IN REG
	MVI	A,OC$RBPH	;RESET BOOT PHANTOM...
	OUT	OMNIDATA	;...TO OMNI
;
;
				;NOTE THAT <HL> = 200H
L3	CALL	CMDLIST
	DB	5		;(LENGTH OF LIST)
	DB	OC$UNIT
	DB	00		;SELECT UNIT 0 TO BOOT FROM
	DB	OC$BOOT,1	;READ ONLY FIRST SECTOR OF BOOT
	DB	OC$GENS
	LXI	H,0000		;READ BOOT SECTOR INTO LOCATION 0000
	CALL	GETDAT
	RET
;
;	FAILURE READING BOOT SECTOR
;
;	RESET GENERAL STATUS BY FETCHING EXTENDED STATUS
;
	CALL	CMDLIST
	DB	2		;(LENGTH OF LIST)
	DB	OC$EXTS		;REQUEST EXTENDED STATUS (SETS GENSTAT=0)
	DB	OC$GENS

;********************************************************
;	SUBROUTINE FOR BLOCK READ			*
;							*
;	NOTE:	THIS SUBROUTINE READS DATA UNTIL	*
;		THE OMNI CONTROLLER ACCEPTS THE		*
;		GENERAL STATUS COMMAND			*
;********************************************************

GETDAT:	IN	OMNISTAT
	RRC
	JNC	GETDAT		;IF NOTHING TO GET FROM OMNI
	ANI	40H		;(WHAT DO WE HAVE HERE: DATA -OR- GEN STATUS?)
	IN	OMNIDATA	;TAKE IT, WHATEVER IT IS
	RZ			;IF IT IS GENERAL STATUS, THEN RETURN
	MOV	M,A		;ELSE...PUT INTO BUFFER
	INX	H
	JMP	GETDAT		;KEEP ON KEEPING ON

;********************************************************
;	SUBROUTINE TO ISSUE COMMAND LIST		*
;********************************************************
CMDLIST:
	XTHL
	MOV	C,M		;FETCH LENGTH OF LIST
	INX	H
CMDLIST1:
	IN	OMNISTAT
	ANI	OUTREADY
	JNZ	CMDLIST1	;IF OMNI NOT READY FOR COMMAND
	MOV	A,M		;NEXT BYTE TO SEND
	INX	H
CMDLIST2 OUT	OMNIDATA
	DCR	C
	JNZ	CMDLIST1	;IF MORE COMMANDS TO SEND
	XTHL
CODELBA	RET			;LABEL DEFINES CODE LAST BYTE ADDRESS (LBA)

;
;******************************************
;	SWITCH OUT MPU-Z AND
;	EXECUTE BOOT ROUTINE
;******************************************
BOOTER 		;SYSTEM CONTROL PORT FOR MAPPINGS
	LXI	H,0
BOOTER1	MVI	A,PCHL
	STA 	BOOTER2
	OUT	00	;CANT SWITH ANYTHING HERE!!
BOOTER2	EQU	$
	PAGE
;****************************************************
;FIND THE APPROPRIATE SYSTEM PORT AND SET BAUD RATE IF
;PORT IS SERIAL
;****************************************************
SETSYSP	
AUTOBAUD
MSG11	LXI  H,MSG1	;HIT SPACE BAR
	CALL SYSMSG
	LXI  H,OUTDEV
	XRA	A	;DE-ALLOCATE ALL OUTPUT
	MOV  M,A
	DCX  H		;MOVE MEM POINTER TO INPUT DEV
	MOV  M,A	;DE-ALLOCATE ALL INPUT
;
	MVI  B,0
	IN	BASE
	CPI	0FFH
	JNZ	KEYOK
	MVI	B,1
	JMP	KEYBAD
KEYOK	MOV	A,B
	ORI	1
	MOV	B,A
KEYBAD
;
;		ALLOCATE AN I/O DEVICE
;			PASS DEVICE MASK IN B
;
ALLOCIO	LXI  H,INDEV	;SET MEM POINTER TO INPUT SELECT BYTE
	MOV  A,M
	ORA  B		;OR DEVICE BIT WITH DEVICE SELECT BYTE
	MOV  M,A
	INX  H		;INCR MEM POINTER TO OUTPUT SELECT BYTE
	MOV  A,M
	ORA  B		;OR DEVICE BIT WITH DEVICE SELECT BYTE
	MOV  M,A
	RET
;
	PAGE
;

;**********************************************
;SELECT BAUD RATE COMMAND
;B <CR>	 AUTOMATIC BAUD RATE SELECTION
;B <RATE><CR> FORCE SPECIFIED STANDARD BAUD RATE
;************************************************
BAUDSEL	CALL IHEX	;READ 16 BIT VALUE
	MOV A,H		;USE HIGH 2 DIGITS AS CODE
	ORA L		;ANY PARM?
	JZ AUTOBAUD	;NO DO AUTOMATIC BAUD SELECT
	MOV A,H		;GET CODE AGAIN
;
BAUDSET	LXI H,BAUDTBL	;POINT AT TABLE
	PUSH B
	CALL LOOKUP	;IS VALUE IN TABLE?
	POP B
	CNZ BAUDSET1	;SET BAUD RATE
	LXI H,MSG6	;"BAUD RATE ERROR"
	JMP  SYSMSG
;
BAUDSET1 



	RET
;
;**************************************************
;	JUMP TO MEMORY "JAAAA"
;	CALL MEMORY WITH RETURN TO MONITOR
;**************************************************
JUMP	POP  D		;REMOVE RETURN ADDRESS
CALL1	CALL IHEX	;GET JUMP ADDRESS
	PCHL
;
;************************************************
;	SWITCH OUT MPU-Z AND JUMP
;	TO LOCATION SPECIFIED
;************************************************
JMPSW	CALL IHEX	;GET ADDR TO JUMP TO
	JMP   BOOTER1
;
;***************************************************
;	ENTER BYTE INTO MEMORY AND MODIFY IF DESIRED
;***************************************************
ENTR	CALL IHEX	;START ADDR
	CALL CRLF
	CALL OHEXHL	;DISPLAY ADDRESS
	CALL EBYTE	;DISPLAY AND CHANGE BYTE
	DCX  H
	CPI  0AH	;DONE?
	RZ		;YES
	CPI  '-'	;BACKWARD?
	JZ   ENTR+3	;YES
	INX  H
	INX  H		;DEFAULT FORWARD
	JMP  ENTR+3
;
EBYTE	MOV  A,M	;GET BYTE IN MEMORY
	MOV  E,A	;PRESET FOR IHEX
	CALL OHEXB	;DISPLAY BYTE
	XCHG		;DE = ADDRESS, L = DEFAULT CHAR
	CALL IHEX+3	;GET MODIFIER OR DEFAULT
	XCHG		;HL = ADDRESS, E = BYTE
	MOV  M,E
	RET
;
;*****************************************************
;	DISPLAY MEMORY "D START,END"
;*****************************************************
DISP	CALL SIZE	;HL = START, BC = SIZE
	MVI  E,24	;SAVE # OF LINES PER BLOCK
	PUSH H		;POINTER TO MEMORY
NXTBLOC	MOV  D,E	;# OF LINES FOR EACH BLOCK
NXTLINE	PUSH D
	MVI  D,17	;NUMBER OF BYTES TO ZERO
	LXI  H,LINE+17	;POINTER TO ASCII PRINT BUFFER
	XRA  A		;ZERO ACCUM
LNZERO	DCX  H
	MOV  M,A	;ZERO BUFFER
	DCR  D
	JNZ  LNZERO
	POP  D
	XTHL		;GET MEM POINTER
	CALL CRLF
	CALL OHEXHL	;PRINT ADDRESS
	CALL SPACE
NXTBYTE	CALL CHIN	;HAS A CHAR BEEN INPUTED?
	JNZ  DISPEX	;YES.  INTERUPT
	MOV  A,M	;GET DATA BYTE
	CALL OHEXB	;PRINT HEX WITH TRAILING BLANK
	MOV  A,M	;GET DATA BYTE
	INX  H		;INCREMENT MEM POINTER
	XTHL		;GET ASCII BUF POINTER
	MOV  M,A	;MOVE DATA TO BUFFER
	CPI  32		;IS DATA LESS THAN BLANK?
	JC   PERIOD	;YES.  INVALID CHAR
	CPI  127	;IS DATA LESS THAN RUB-OUT?
	JC   CHAROK	;YES.  CHARACTER IS OK
PERIOD	MVI  M,'.'	;MOVE PERIOD TO BUFFER
CHAROK	INX  H		;INCREMENT BUF POINTER
	DCX  B
	MOV  A,B
	ORA  C		;WAS THAT THE LAST BYTE?
	JZ   PRNTASC	;YES.  PRINT ASCII BUFFER
	XTHL
	MOV  A,L	;GET LOW LOW ORDER ADDR OF MEM
	ANI  0FH	;IS IT TIME FOR NEXT LINE?
	JNZ  NXTBYTE	;NO.  PROCESS NEXT BYTE
	XTHL
PRNTASC	CALL SPACE
	LXI  H,LINE	;GET ADDR TO ASCII BUFFER
	CALL SYSMSG	;PRINT ASCII BUFFER
	MOV  A,B
	ORA  C		;WAS THAT THE LAST BYTE?
	JZ   DISPEX	;YES.  EXIT ROUTINE
	DCR  D		;READY TO PAUSE?
	JNZ  NXTLINE	;NO.  DO NEXT LINE
	CALL CHARIN	;PAUSE UNTIL A CHAR IS TYPED
	CALL CRLF
	JMP  NXTBLOC	;DO NEXT BLOCK OF DATA
DISPEX	POP  H
	JMP  CRLF	;EXIT DISPLAY ROUTINE
;
;*******************************************************
;	INTEL LOADER LOADS INTEL FORMAT TAPES FROM
;		INPUT DEVICE.
;*******************************************************
INTEL	CALL SYSIN	;READ CHARACTER
	SUI  ':'	;RECORD MARKER?
	JNZ  INTEL	;NO
	MOV  D,A	;ZERO CHECKSUM
	CALL IBYTE	;INPUT 2 HEX CHARS
	RZ		;COUNT = 0  MEANS END
	MOV  B,E	;BYTE COUNT
	CALL IBYTE
	MOV  H,E
	CALL IBYTE
	MOV  L,E
	CALL IBYTE	;DUMMY RECORD TYPE IGNORED
DATA	CALL IBYTE
	MOV  M,E
	INX  H
	DCR  B
	JNZ  DATA
	CALL IBYTE	;READ AND ADD CHECKSUM
	JZ   INTEL	;OK AS IS
	MVI  A,'C'
	JMP  CHAROUT	;ERROR MESSAGE
;
;***********************************************************
;	READ 2 ASCII HEX BYTES AND CONVERT TO BINARY
;***********************************************************
IBYTE	CALL SYSIN	;READ CHARACTER
	CALL ASCBI	;CONVERT TO BINARY
	JC   ERR21
	ADD  A
	ADD  A
	ADD  A
	ADD  A
	MOV  E,A	;SAVE
IBYTE2	CALL SYSIN	;INPUT CHAR
	CALL ASCBI
	JC   ERR21	;INVALID ASCII HEX CHAR
	ADD  E
	MOV  E,A	;SAVE CHAR
	ADD  D		;ADD TO CHECKSUM
	MOV  D,A
	RET

ERR21	MVI  A,'T'	; ERROR CODE
ERR1	CALL CHAROUT
	RET
;
;*******************************************
;	MEMORY TEST ROUTINE
;*******************************************
MEMTEST	CALL SIZE	;HL = START, BC = SIZE
	DCX  B		;BC = SIZE-1  OR  0
MEM2	XRA  A
	MOV  D,M	;SAVE CELL
MEM1	MOV  M,A
	CMP  M
	JNZ  MEMERR	;NOT GOOD
	DCR  A		;NEXT PATTERN
	JNZ  MEM1
	MOV  M,D	;RESTORE MEMORY
	CALL CHIN	;BAIL OUT?
	RNZ		;YES
	INX  H
	DCX  B
	MOV  A,B
	ORA  C
	JNZ  MEM2
	RET
MEMERR	INX  H		;ADJUST FOR PRNMEM
	MOV  E,A	;SAVE
	CALL PNTMEM	;PRINT ADDR, CONTENTS
	MOV  A,E	;RESTORE
	JMP  SRCPNT1	;PRINT SHOULD BE
;
;***********************************************************
;	MEMORY MOVE "M SOURCE BEG, SOURCE END, DEST
;***********************************************************
MOVE	CALL PARM4	;START, END, DEST
MOVE1	JMP  MVCUP	;DO MOVE
;
;********************************************
;	FILL MEMORY WITH CHAR
;********************************************
FILL	CALL PARM4	;START, END, FILL CHAR IN L
	MOV  A,E	;FILL CHAR
	MOV  M,A	;STORE IN FIRST LOCATION
	DCX  B
	MOV  D,H
	MOV  E,L	;DEST ADDR
	INX  D		;=START ADDR+1
	JMP  MOVE1
;
;******************************************************
;	DO DIRECT I/O FROM SPECIFIED PORT
;******************************************************
INPORT	DCR  B		;B = 0 = INPUT, B = 1 = OUTPUT
OUTPORT	CALL PARM5	;INPUT PORT, VALUE IN HL AND DE
	MOV  A,B	;FLAG
	RLC
	RLC
	RLC
	XRI  0DBH	;FORM I/O INSTRUCTION
	MOV  D,L
	LHLD VRAMPTR	;GET POINTER TO I/O RAM
	MOV  M,A
	CMP  M
	RNZ		;INVALID RAM
	PUSH H
	INX  H
	MOV  M,D	;PORT #
	INX  H
	MVI  M,0C9H	;RETURN
	LXI  H,IORET
	XTHL		;PUT RETURN ADDR, GET START ADDR
	MOV  A,B
	ORA  A		;SET FLAG FOR IN OR OUT
	MOV  A,E	;OUTPUT BYTE
	PCHL
IORET	JZ   OHEXB	;PRINT IF INPUT
	RET		;ELSE RETURN
;
;
;************************************************
;	RELOCATE I/O RAM
;************************************************
RELIO	CALL IHEX	;GET ADDRESS
	MOV  A,H
	ORA  L		;IS ADDR ZERO?
	JNZ  $+6	;NO.  SKIP NEXT INSTR
	LXI  H,IORAM	;DEFAULT ADDRESS
	SHLD VRAMPTR	;SAVE ADDRESS
	RET
;
;******************************************************
;	COMPARE MEMORY BLOCKS AND PRINT DIFFERENCES
;******************************************************
CMPBLK	CALL PARM4	;HL = START, BC = END, DE = DEST
CMPBLK1	LDAX D		;DEST BYTE
	CMP  M		;SAME AS SOURCE BYTE?
	INX  H
	INX  D
	JZ   CMPB1	;YES.  DONT PRINT
	CALL PNTMEM	;PRINT ADDR, SOURCE DEST
	XCHG
	CALL PNTMEM+3	;NO CRLF
	XCHG
CMPB1	DCX  B
	MOV  A,B
	ORA  C
	RZ		;YES, RETURN
	CALL CHIN	;BAIL OUT?
	RNZ		;YES
	JMP  CMPBLK1
;
;********************************************************
;	SEARCH FOR MASKED 16 BIT VALUE
;	"S BEG, END, 16 BIT VALUE, 16 BIT MASK"
;********************************************************
SEARCH	CALL PARM4	;HL = START, BC = SIZE, DE = VALUE
	PUSH H		;SAVE
	LXI  H,-1	;DEFAULT MASK ALL
	CPI  0AH	;USER SPECIFIED MASK?
	CNZ  IHEX	;YES, READ IT INTO HL
	XTHL		;MASK ON STACK, START IN HL
SEARCH1	MOV  A,M	;LOW BYTE
	XTHL		;HL = MASK VALUE
	ANA  H		;MASK HIGH BYTE
	CMP  D		;IS IT CORRECT VALUE?
	XTHL		;RESTORE START POINTER
	INX  H		;BUMP POINTER
	JNZ  CMP16	;NO MATCH
	MOV  A,M	;LOW BYTE
	XTHL		;GET MASK IN HL
	ANA  L
	CMP  E
	XTHL		;HL = START, STACK = MASK
	CZ   SRCPNT	;PRINT MATCH IF FOUND
CMP16	DCX  B
	MOV  A,B
	ORA  C
	JNZ  SEARCH1
	POP  B		;REMOVE MASK VALUE
	RET
;
;************************************************************
;	MOVE BC CHARS FROM HL TO DE FROM BOTTOM
;************************************************************
MVCUP	MOV  A,B
	ORA  C
	RZ
	MOV  A,M
	STAX D		;MOVE IT
	DCX  B
	INX  H
	INX  D
	JMP  MVCUP	;KEEP GOING
;
;********************************
;	BOOT FROM DISKETTE
;********************************
BOOT	CALL CRLF
	CALL TRYBOOT	;FIND MAIN DRIVE AND TRY TO READ IN A SECTOR
	ORA	A		;GENERAL STATUS
	JZ	BOOTER		;IF BOOT READ OK, GO FIRE UP BOOT
;
;*********************************************
;	DISK ERROR HANDLER
;*********************************************
DISKERR	ANI  0F0H	;MASK OUT UNIT # BITS
	LXI  H,DSKERR1
	CPI  0A0H	;IS DISK READY?
	JZ   SYSMSG	;NO.  PRINT "DISK NOT READY"
	LXI  H,DSKERR2
	CALL SYSMSG	;PRINT "DISK ERROR-- "
	LHLD DSTRBUF	;GET ADDR OF DISK COMAND STRING
	INX  H
	MOV  A,M	;GET STATUS
	JMP  OHEX	;PRINT STATUS
DSKERR1	DB  'NOT READY',0
DSKERR2	DB  'DISK ERR- ',0
;
;*********************************************
;	ROUTINE TO LOAD A SECTOR
;	TO OR FROM DISKETTE
;*********************************************
LOADER	LHLD DSTRBUF	;ADDR OF COMMAND STRING
	LXI  D,DSKCMDST	;ADDR OF DATA TO GO INTO COMMAND STRING
	MVI  B,7	;LENGTH OF DATA TO BE TRANSFERED
TRANSFR XCHG
	MOV  A,M	;MOVE DATA TO ACCUM
	XCHG
	MOV  M,A	;MOVE ACCUM TO COMMAND STRING
	INX  H
	INX  D
	DCR  B
	JNZ  TRANSFR
;
	MVI  A,10H	;SET COMMAND STRING POINTER 0
	CALL DISK
	LHLD DSTRBUF	;GET ADDR OF COMMAND STRING
	MOV  A,L	;LOW ADDR FOR CMD STRING
	CALL DISK
	MOV  A,H	;HIGH ADDR FOR CMD STRING
	CALL DISK
	XRA  A		;EXECUTE COMMAND STRING
	CALL DISK
;
	LXI  D,0	;INITIALIZE LOOP
	MVI  B,2
	LHLD DSTRBUF	;GET ADDR OF CMD STRING
	INX  H
WAITLP	MOV  A,M	;GET STATUS
	ORA  A		;HAS IT CHANGED YET?
	RNZ		;YES.  RETURN
	DCR  D
	JNZ  WAITLP	;TRY AGAIN...
	DCR  E
	JNZ  WAITLP	;AND AGAIN.
	DCR  B
	JNZ  WAITLP
	RET		;NO CHANGE...  Z FLAG IS SET
;
;*****************************************
;	   READ AND WRITE SECTOR
;	R TRACK,SECTOR,BUFFER,UNIT
;	W TRACK,SECTOR,BUFFER,UNIT
;*****************************************
READ	;CALL ZERCMD	;ZERO COMMAND STRING FOR READ
	JMP  LOAD	;GET PARAMETERS AND READ SECTOR
;
WRITE	;CALL ZERCMD	;ZERO COMMAND STRING
	MVI  M,11H	;WRITE SECTOR TO UNIT # 0
;
;*****************************************
;	GET PARAMETERS AND READ OR
;	WRITE SECTOR
;*****************************************
LOAD	CALL PARM5	;HL = TRACK, DE = SECTOR
	STA  ASAVE	;STORE CHAR FOLLOWING HEX CHARS
	MOV  A,L
	ORA  E		;ARE THERE NO PARAMETERS?
	JZ   ERR	;NO PARMS.  PRINT " ? "
	SHLD DTRACK+1	;STORE TRACK #
	MOV  A,E
	STA  DSECTOR	;STORE SECTOR #
	LDA  ASAVE
	CPI  0AH	;WAS THERE A RETURN TYPED?
	JZ   LOAD1	;YES.  CALL LOADER
	CALL PARM5	;HL = BUFFER, DE = UNIT #
	SHLD DBUF	;STORE ADDR OF BUFFER
	MOV  A,E
	ANI  3		;MASK UNWANTED BITS
	INR  A
	MOV  E,A
	XRA  A		;ZERO OUT ACCUM
	STC		;SET CARRY BIT
SHIFT	RAL		;SHIFT BIT OVER ONE
	DCR  E		;FOUND UNIT # YET?
	JNZ  SHIFT	;NO.  KEEP GOING
	MOV  E,A
	LXI  H,CMDUNIT
	MOV  A,M	;GET COMMAND IN STRING
	ANI  0F0H	;MASK OUT EVERYTHING ELSE
	ORA  E		;OR IN UNIT #
	MOV  M,A	;SAVE IN COMMAND STRING
LOAD1	CALL LOADER	;EXECUTE READ OR WRITE
	DCR  A		;WAS IT SUCCESFUL?
	RZ		;YES. RETURN
	JMP  DISKERR
;
;*****************************************
;	DO DISK INTERFACE I/O
;*****************************************
DISK	STA  ASAVE	;SAVE ACCUM
	LDA  DISKDRV	;GET TYPE OF DRIVE
	LDA  ASAVE
	OUT  0FDH	;FIF PORT
	RET
;
DMAXY	CPI  DIOMAXY	;IS IT A REGULAR DISKETTE?
	LDA  ASAVE
	JZ   0E006H	;YES.  JUMP TO DIO
	JMP  0E009H	;NO.  JUMP TO MINI DIO
;
;*****************************************
ERR	LXI  H,QUEST
	JMP  SYSMSG
QUEST	DB   'INVALID',0
;
	PAGE
;
;******************************************
;	DEVICE ALLOCATION
;******************************************
ALDISK	LXI  H,DISKDRV	;DISK ALLOCATION
	JMP  EBYTE	;DISPLAY AND RE-ENTER BYTE
;
ALINPUT	LXI  H,INDEV	;INPUT ALLOCATION
	JMP  EBYTE	;DISPLAY AND RE-ENTER BYTE
;
ALOUTPT	LXI  H,OUTDEV	;OUTPUT ALLOCATION
	JMP  EBYTE	;DISPLAY AND RE-ENTER BYTE
;
	PAGE
;*********************
;SIZE INPUT START END
;*********************
SIZE	CALL PARM2	;H,L=START,D,E=END
	PUSH A
	MOV A,E
	SUB L
	MOV C,A
	MOV A,D
	SBB H
	MOV B,A
	INX B
	POP A
	RET
;
;***********************************
;PARM2 READ 2 PARMS INTO H,L AND D,E
;**********************************
PARM2	CALL IHEX
	MOV D,H
	MOV E,L		;USE SAME FOR DEFAULT
PARM6	CPI 0AH		;TERMINATED?
	RZ		;YES
	CPI ' '
	JZ PARM3
	CPI ','
	RNZ		;INVALID
PARM3	XCHG
	CALL IHEX	;2ND PARM
	XCHG
	RET
PARM4	CALL SIZE	;INPUT  START, END, VALUE
	JMP  PARM3	;CONVERT TO HL=START, BC=SIZE, DE=VALUE
PARM5	CALL IHEX
	LXI  D,0
	JMP  PARM6
;
	PAGE
;*******************
;SYSTEM SUBROUTINES
;*******************
;
;****************************************
;LOOKUP IN 3 BYTE TABLE
;************************
LOOKUP	MOV B,A		;SAVE
	MOV A,M
	ORA A
	RZ		;NOT FOUND Z FLAG SET
	CMP B		;MATCH?
	INX H
	JZ LOOKM	;YES
	INX H
	INX H		;TRY NEXT ENTRY
	JMP LOOKUP+1
LOOKM	MOV B,M
	INX H
	MOV H,M
	MOV L,B
	ORA A		;SET NOT ZERO
	RET
;
;*********************************
;I/O DRIVERS
;****************
SERIN	IN   BASE	;SERIAL PORT CONTROL PORT
	ANI  4
	RZ
	IN   BASE + 1
	RET
;
KEYIN	IN   BASE	;SYSTEM CONTROL PORT
	ANI  4
	RZ
	IN   BASE	;INPUT DATA
	RET
;
SERINB	IN   BASE + 2	;SERIAL PORT B
	ANI  4
	RZ
	IN   BASE + 3
	RET
;
;*************************
SEROUT	IN   BASE + 1
	ANI  1
	JZ   SEROUT	;WAIT UNTIL READY
	LDA  ASAVE	;GET OUTPUT CHAR
	OUT  BASE + 2
	RET
;
SEROUTB	IN   BASE + 3
	ANI  1
	JZ   SEROUTB	;WAIT UNTIL READY
	LDA  ASAVE	;GET OUTPUT CHAR
	OUT  BASE + 4
	RET
;
KEYOUT	IN   BASE + 1
	ANI  1		;READY TO OUTPUT?
	JZ   KEYOUT	;NO.  NOT YET
	LDA  ASAVE	;YES. GET CHAR TO OUTPUT
	OUT  BASE +2
	RET
;
PAROUT	IN   BASE + 7
	ANI  2		;READY TO OUTPUT?
	JZ   PAROUT	;NO.  NOT YET
	LDA  ASAVE	;YES. GET CHAR TO OUTPUT
	OUT  BASE + 7
	RET
;
;*********************************
;SYSTEM INPUT
;*********************************
CHARIN	CALL CHIN	;INPUT CHARACTER, IF ANY
	JZ   CHARIN	;TRY AGAIN, IF NO INPUT
	RET
;
CHIN	LDA  INDEV	;INPUT ALLOCATION BYTE
	ANI  KEYFLAG	;TRY SYSTEM PORT?
	CNZ  KEYIN	;YES
	RNZ		;RETURN IF INPUT
	LDA  INDEV
	ANI  SERFLAG	;TRY SERIAL PORT?
	CNZ  SERIN	;YES
	RNZ		;Z FLAG SET IF NO INPUTS.
	LDA  INDEV
	ANI  SERFLGB	;TRY SERIAL PORT?
	CNZ  SERINB	;YES
	RET		;Z FLAG SET IF NO INPUTS.
;
;*********************************
;SYSTEM OUTPUT
;*********************************
SYSMSGCR CALL CRLF
SYSMSG	MOV  A,M	;GET NEXT CHAR
	ORA A		;IS IT TERMONATOR
	RZ		;YES,ALL DONE
	PUSH B		;SAVE B
	MOV B,A
	CALL SYSOUT	;OUTPUT IT TO SYSTEM DEVICE
	POP B		;RESTORE B
	INX H
	JMP SYSMSG
;
;******************************
;SYSOUT SENDS CHARACTERS TO SELECTED
;	SYSTEM DEVICE
;**********************************
CHAROUT
SYSOUT	STA  ASAVE	;SAVE ACCUM
	PUSH H		;SAVE HL
	LXI  H,OUTDEV	;OUTPUT SELECT BYTE
;
	MOV  A,M
	ANI  SERFLAG	;SERIAL?
	CNZ  SEROUT
;
	MOV  A,M
	ANI  KEYFLAG	;SYSTEM?
	CNZ  KEYOUT
;
	MOV  A,M
	ANI  PARFLAG	;SYSTEM?
	CNZ  PAROUT
;
	MOV  A,M
	ANI  SERFLGB	;SERIALB?
	CNZ  SEROUTB
	LDA	ASAVE
	POP	H
	RET
;
;
;*****************************************
;SYSIN READ CHAR AND ECHO TO SYSTEM DEVICE
;  AND CONVERT TO UPPER CASE
;*****************************************
SYSIN	CALL CHARIN	;READ NEXT CHAR TYPED
	ANI  7FH	;REMOVE PARITY BIT
	CPI  0DH	;WAS IT A RETURN?
	JZ   CRLF	;YES.  PRINT CR AND LF
	CPI  03H	;WAS IT A CONTROL ^C ?
	JZ   PRMPTSP	;YES.  RESET STACK AND GO ON TO NEXT COMMAND
	CPI  15H	;WAS IT A CONTROL ^U ?
	JZ   PRMPTSP	;YES.  RESET STACK AND GO ON TO NEXT COMMAND
	CALL SYSOUT	;ECHO CHARACTER
	CPI  1BH	;WAS IT AN <ESC> CHAR?
	JNZ  UPPER	;NO.  CONVERT TO UPPER CASE AND RETURN
	CALL SYSIN	;YES. PRINT NEXT CHAR
	JMP  SYSIN	;CONTINUE TO NEXT CHAR
;
UPPER	CPI  'A'+20H	;LOWER CASE A
	RC		;RETURN IF < L.C. A
	CPI  'Z'+21H	; L.C. Z +1
	RNC		;RETURN IF > L.C. Z
	XRI  20H	;CONVERT TO UPPER CASE
	RET
;
;*****************************
;CRLF CARRIAGE RETURN/LINE FEED
;*****************************
CRLF	MVI A,0DH
	CALL SYSOUT
	MVI A,0AH
	JMP  SYSOUT
;
;***********************
;OUTPUT HEX ASCII VALUE
;***********************
OHEX	PUSH A
	RRC
	RRC
	RRC
	RRC
	CALL BIAS	;BINARY TO ASCII
	POP A
BIAS	ANI 0FH		;MASK NIBBLE
	ADI 90H
	DAA
	ACI 40H
	DAA
	JMP  SYSOUT
;
;************************************
;OHEXHL-OUTPUT H,L REG TO SYSTEM OUTPUT
;************************************
OHEXHL	MOV  A,H
	CALL OHEX
	MOV A,L
OHEXB	CALL OHEX
SPACE	MVI A,' '
	JMP  SYSOUT
;
;***************************
;INPUT 16 BIT HEX VALUE FROM
;SYSTEM INPUT DEVICE
;***************************
IHEX	LXI H,0		;DEFAULT VALUE
	CALL SYSIN
	PUSH A
	CALL ASCBI	;CONVERT TO ASCII
	JNC IHEX1	;VALID DIGIT
	POP A
	RET		;A=FIRST INVALID CHAR
IHEX1	DAD H
	DAD H
	DAD H
	DAD H
	ADD L
	MOV L,A		;MERGE IN NEW DIGIT
	POP A
	JMP IHEX+3
;
;********************************
;ASCII TO BINARY CONVERSION
;********************************
ASCBI	SUI 30H
	RC
	CPI 10
	JC ASCBI1
	SUI 17
	RC
	ADI 10
	CPI 16
ASCBI1	CMC
	RET
;
;********************************
;PRINT HL AND 16 BIT MEMORY AT HL
;********************************
SRCPNT	CALL PNTMEM
	MOV  A,M	;BYTE 2
SRCPNT1	CALL OHEX
	RET
PNTMEM	CALL CRLF
	DCX  H		;BACK UP 1
	CALL OHEXHL
	MOV  A,M
	CALL OHEXB
	INX  H
	RET
;
;********************************
	PAGE
BAUDTBL	DB 	19H	;19.2K
	DW	0FH
	DB 	96H	;9600
	DW 	0EH
	DB 01H		;110
	DW 	02H
	DB 03H		;300
	DW 	05H
	DB 48H		;4800
	DW 	0CH
	DB 24H		;2400
	DW 	0AH
	DB 12H		;1200
	DW 	07H
	DB 06H		;600
	DW 	06H
	DB 0
	

CMDTBL	DB 'A'
	DW 0		;NA
	DB 'B'
	DW BOOT		;BOOT SYSTEM
	DB 'C'
	DW CALL1	;CALL MEMORY WITH RETURN
	DB 'D'
	DW DISP		;DISPLAY MEMORY
	DB 'E'
	DW ENTR		;EXAMINE AND ENTER INTO MEMORY
	DB 'F'
	DW FILL		;FILL MEMORY
	DB 'G'
	DW 0		;***********
	DB 'H'
	DW INTEL	;LOAD INTEL HEX FORMAT
	DB 'I'
	DW INPORT	;INPUT FROM SPECIFIED PORT
	DB 'J'
	DW JUMP		;JUMP TO ADDRESS
	DB 'K'
	DW 0		;*************
	DB 'L'
	DW 0		;****************
	DB 'M'
	DW MOVE		;MOVE MEMORY BLOCK
	DB 'N'
	DW 0		;**************
	DB 'O'
	DW OUTPORT	;OUTPUT TO SPECIFIED PORT
	DB 'P'
	DW 0		;****************
	DB 'Q'
	DW 0		;****************
	DB 'R'
	DW READ		;READ SECTOR FROM DISKETTE
	DB 'S'
	DW SEARCH	;16 BIT MASKED SEARCH
	DB 'T'
	DW MEMTEST	;TEST MEMORY
	DB 'U'
	DW 0		;***************
	DB 'V'
	DW CMPBLK	;COMPARE MEMORY BLOCKS
	DB 'W'
	DW WRITE	;WRITE SECTOR TO DISKETTE
	DB 'X'
	DW 0		;****************
	DB 'Y'
	DW RELIO	;RELOCAT I/O RAM
	DB 'Z'
	DW BAUDSEL	;SELECT BAUD RATE
	DB ':'
	DW TBLSET2	;SET UP FOR SECOND CMD TABLE
CMDTBL2	DB 'D'
	DW ALDISK	;DISKETTE ALLOCATION
	DB 'I'
	DW ALINPUT	;INPUT ALLOCATION
	DB 'O'
	DW ALOUTPT	;OUTPUT ALLOCATION
	DB 0
;******************************************
;SYSTEM MESSAGES
;*****************
	DB '(C)1984 '
SIGNON	DB ' MONITOR',0
MSG1	DB 'HIT SPACE BAR',0DH,0AH,0
MSG6	DB 'INVALID BAUD',0
MSGSER	DB 'BAUD SERIAL',0DH,0AH,0
MSGPAR	DB 'PARALLEL',0DH,0AH,0
STMSG	DB 'TYPE N TO SELECT NEXT FIELD',0DH,0AH
	DB '   TYPE + TO INCREMENT SELECTED FIELD',0DH,0AH
	DB '   TYPE - TO DECREMENT SELECTED FIELD',0DH,0AH,0
SETTING DB '  SETTING: ',0
SPACES 	DB '               ',0
	END

